package inVivo;

import ij.IJ;

import java.awt.* ;
import java.io.File;
import javax.swing.* ;

public class InVivoInterface extends JFrame
{
	StkImage_ graph;
	private JPanel jPanel = null;
	private JMenuBar jMenuBar = null ;
	private JMenu jMenu = null;
	private JMenu jMenu2 = null;
	private JMenuItem jMenuItem1 = null;
	private JMenuItem jMenuItem2 = null;
	private JMenuItem jMenuItem3 = null;
	private JMenuItem jMenuItem4 = null;
	private JToolBar jToolBar = null;
	private JButton jButton = null;
	private JButton jButton2 = null;
	private JButton jButton3 = null;
	private JButton jButton4 = null;
	File mondossier= null;
    String monfichier= null;
	public InVivoInterface (StkImage_ sub)
	{
		super();
		graph = sub;
		initialisation();
	}
	private void initialisation()
	{
		   //setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));
	       setTitle("InVivo Plugin") ;
	       setIconImage(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/inVivo/brain.gif")));
	       setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
	       setBounds(85, 150, 200, 104) ;
	       setJMenuBar(getJMenuBar());
	       setName("JFrame2");
	       setContentPane(getJPanel());
	       //setResizable(false); permet de ne pas pourvoir agrandir la fentre
	}
	public JMenuBar getJMenuBar()
	{
		if (jMenuBar == null) 
		{
			jMenuBar = new JMenuBar();
			jMenuBar.add(getJMenu());
			jMenuBar.add(getJMenu2());
		}
		return jMenuBar;	
	}
	private JPanel getJPanel() 
	{
		if (jPanel == null) 
		{
			jPanel = new JPanel();
			//jPanel.setLayout(new BoxLayout(jPanel, BoxLayout.Y_AXIS));
			jPanel.setLayout(new BorderLayout());
			jPanel.setMinimumSize(new java.awt.Dimension(400,31));
			jPanel.setMaximumSize(new java.awt.Dimension(800,31));
			jPanel.add(getJToolBar());
		}
		return jPanel;
	}
	private JMenu getJMenu()
	{
		if (jMenu == null) 
		{
			jMenu = new JMenu();
			jMenu.setText("Fichier");
			jMenu.setToolTipText("ouverture ...");
			jMenu.add(getJMenuItem1());
			jMenu.add(getJMenuItem2());
			jMenu.addSeparator();
			jMenu.add(getJMenuItem3());
		}
		return jMenu;
	}
	private JMenuItem getJMenuItem1()
	{
		if (jMenuItem1 == null) 
		{
			jMenuItem1 = new JMenuItem();
			jMenuItem1.setText("Ouvrir une image...");
			jMenuItem1.setToolTipText("Ouvre une image au format stk et son aperu");
			jMenuItem1.addActionListener(new java.awt.event.ActionListener()
			{ 
				public void actionPerformed(java.awt.event.ActionEvent e) 
				{    
					JFileChooser filechoose = new JFileChooser();
					filechoose.setCurrentDirectory(new File("."));
					String approve = new String("Ouvrir");
					int resultatEnregistrer = filechoose.showDialog(filechoose,approve);
					if (resultatEnregistrer == JFileChooser.APPROVE_OPTION)
						monfichier = filechoose.getSelectedFile().toString();
					IJ.open(monfichier);
					jMenuItem4.setEnabled(true);
					jButton4.setEnabled(true);
				}
			});
		}
		return jMenuItem1;
	}
	private JMenuItem getJMenuItem2()
	{
		if (jMenuItem2 == null) 
		{
			jMenuItem2 = new JMenuItem();
			jMenuItem2.setText("Ouvrir un dossier...");
			jMenuItem2.setToolTipText("Ouvre un dossier de fichiers stk et les rectifie");
			jMenuItem2.addActionListener(new java.awt.event.ActionListener()
			{ 
				public void actionPerformed(java.awt.event.ActionEvent e) 
				{   
					JFileChooser directorychoose = new JFileChooser();
					directorychoose.setCurrentDirectory(new File("."));
					directorychoose.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY );
					String approve = new String("Charger");
					int resultatEnregistrer = directorychoose.showDialog(directorychoose,approve); 
					if (resultatEnregistrer == JFileChooser.APPROVE_OPTION) 
						mondossier = directorychoose.getSelectedFile();
					graph.ouvertureDossier(mondossier);
				}
			});
		}
		return jMenuItem2;
	}
	private JMenuItem getJMenuItem3()
	{
		if (jMenuItem3 == null) 
		{
			jMenuItem3 = new JMenuItem();
			jMenuItem3.setText("Fermer");
			jMenuItem3.setToolTipText("Fermer le plugin InVivo");
			jMenuItem3.addActionListener(new java.awt.event.ActionListener()
			{ 
				public void actionPerformed(java.awt.event.ActionEvent e) 
				{   
					graph.sortir();
				}
			});
		}
		return jMenuItem3;
	}
	private JMenu getJMenu2()
	{
		if (jMenu2 == null) 
		{
			jMenu2 = new JMenu();
			jMenu2.setText("Image");
			jMenu2.setToolTipText("Traitements et travail sur l'image");
			jMenu2.add(getJMenuItem4());
		}
		return jMenu2;
	}
	private JMenuItem getJMenuItem4()
	{
		if (jMenuItem4 == null) 
		{
			jMenuItem4 = new JMenuItem();
			jMenuItem4.setText("Rectification");
			jMenuItem4.setToolTipText("Rectifier le stack d'images (problmes de translations)");
			jMenuItem4.setEnabled(false);
			jMenuItem4.addActionListener(new java.awt.event.ActionListener()
			{ 
				public void actionPerformed(java.awt.event.ActionEvent e) 
				{   
					graph.rectification(monfichier);
				}
			});
		}
		return jMenuItem4;
	}
	private JToolBar getJToolBar() 
	{
		if (jToolBar == null) 
		{
			jToolBar = new JToolBar();
			jToolBar.setPreferredSize(new java.awt.Dimension(360,40));
			jToolBar.setAlignmentX(0.0F);
			jToolBar.setDoubleBuffered(false);
			jToolBar.setComponentOrientation(java.awt.ComponentOrientation.LEFT_TO_RIGHT);
			jToolBar.setAutoscrolls(false);
			jToolBar.setMaximumSize(new java.awt.Dimension(1000,29));
			jToolBar.add(getJButton());
			jToolBar.add(getJButton2());
			jToolBar.add(getJButton3());
			jToolBar.add(getJButton4());
		}
		return jToolBar;
	}
	private JButton getJButton() 
	{
		if (jButton == null) 
		{
			jButton = new JButton();
			jButton.setPreferredSize(new java.awt.Dimension(20,20));
			jButton.setIcon(new ImageIcon(getClass().getResource("/inVivo/ouvrirfichier.jpg")));
			jButton.setToolTipText("Ouvrir une image stk");
			jButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) { 
					JFileChooser filechoose = new JFileChooser();
					filechoose.setCurrentDirectory(new File("."));
					String approve = new String("Ouvrir");
					int resultatEnregistrer = filechoose.showDialog(filechoose,approve);
					if (resultatEnregistrer == JFileChooser.APPROVE_OPTION)
						monfichier = filechoose.getSelectedFile().toString();
					IJ.open(monfichier);
					jMenuItem4.setEnabled(true);
					jButton4.setEnabled(true);
				}
			});
		}
		return jButton;
	}
	private JButton getJButton2() 
	{
		if (jButton2 == null) 
		{
			jButton2 = new JButton();
			jButton2.setPreferredSize(new java.awt.Dimension(20,20));
			jButton2.setIcon(new ImageIcon(getClass().getResource("/inVivo/ouvrirdossier.jpg")));
			jButton2.setToolTipText("Ouvrir et traiter (rectification) un dossier contenant des .stk");
			jButton2.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) { 
					JFileChooser directorychoose = new JFileChooser();
					directorychoose.setCurrentDirectory(new File("."));
					directorychoose.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY );
					String approve = new String("Charger");
					int resultatEnregistrer = directorychoose.showDialog(directorychoose,approve); 
					if (resultatEnregistrer == JFileChooser.APPROVE_OPTION) 
						mondossier = directorychoose.getSelectedFile();
					graph.ouvertureDossier(mondossier);
				}
			});
		}
		return jButton2;
	}
	private JButton getJButton3() {
		if (jButton3 == null) {
			jButton3 = new JButton();
			jButton3.setMaximumSize(new java.awt.Dimension(16,16));
			jButton3.setMinimumSize(new java.awt.Dimension(16,16));
			jButton3.setPreferredSize(new java.awt.Dimension(16,16));
			jButton3.setOpaque(false);
			jButton3.setEnabled(false);
			jButton3.setBorder(javax.swing.BorderFactory.createEmptyBorder(0,0,0,0));
		}
		return jButton3;
	}
	private JButton getJButton4() 
	{
		if (jButton4 == null) 
		{
			jButton4 = new JButton();
			jButton4.setPreferredSize(new java.awt.Dimension(20,20));
			jButton4.setIcon(new ImageIcon(getClass().getResource("/inVivo/rectification.jpg")));
			jButton4.setToolTipText("Rectifier le stack d'images (problmes de translations) et enregistrer le stack rectifi dans le mme dossier");
			jButton4.setEnabled(false);
			jButton4.addActionListener(new java.awt.event.ActionListener() 
			{ 
				public void actionPerformed(java.awt.event.ActionEvent e) 
				{ 
					graph.rectification(monfichier);	
				}
			});
		}
		return jButton4;
	}
}
