package analysisOperations;

import ij.measure.ResultsTable;
import operations.Operation;

public class MeasureMaskAreaOperation extends Operation {
	ResultsTable measurements;
	/**
	 * 
	 */
	private static final long serialVersionUID = -3578980958793584230L;
	
	/**
	 * @throws ClassNotFoundException
	 *  
	 */
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("ij.measure.ResultsTable");
		resultNames = new String[1];
		resultNames[0] = "Measurements";
	}

	public ResultsTable getMeasurements() {
		return measurements;
	}

	public void setMeasurements(ResultsTable measurements) {
		this.measurements = measurements;
	}
	
	public void doIt() {
		MeasureOperation measure = new MeasureOperation();
		measure.setMeasureIntegratedDensity(true);
		measure.setInputImage(this.getInputImage());
		measure.doIt();
		ResultsTable tmpMeasurements = measure.getMeasurements();
		double area = (tmpMeasurements.getValue(ResultsTable.INTEGRATED_DENSITY, 0) / (255 * 1.0d));
		System.out.println(area);
		this.measurements = new ResultsTable();
		this.measurements.reset();
		this.measurements.setHeading(0,"area");
		this.measurements.incrementCounter();
		this.measurements.addValue(0, area);
		if (this.getShowResult()) this.measurements.show("mask area");
	}
}
