/*
 * Created on 02.11.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package analysisOperations;

import java.io.File;

import ij.ImagePlus;
import ij.text.TextPanel;
import gui.BooleanOption;
import gui.Option;
import gui.Options;
import operations.Operation;
import particleTracking.MRIMTrack2_;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TrackParticlesOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = 6214834452229289276L;
	
	protected Option minSize;
	protected Option maxSize;
	protected Option minTrackLength;
	protected Option maxVelocity;
	protected Option resultFilename;
	protected BooleanOption showLabels;
	protected BooleanOption showPositions;
	protected BooleanOption showPaths;
	protected BooleanOption showPathLengths;
	protected Option maxColumns;
	protected MRIMTrack2_ mTrack2Plugin;
	protected ImagePlus pathsImage;
	protected TextPanel trackMeasurements;
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		// Set parameterTypes, parameterNames and resultType
		optionsNames = new String[10];
		optionsNames[0] = "min size";
		optionsNames[1] = "max size";
		optionsNames[2] = "min track length";
		optionsNames[3] = "max velocity";
		optionsNames[4] = "result filename";
		optionsNames[5] = "show labels";
		optionsNames[6] = "show positions";
		optionsNames[7] = "show paths";
		optionsNames[8] = "show path lengths";
		optionsNames[9] = "max columns";
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		resultTypes = new Class[3];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultTypes[1] = Class.forName("ij.ImagePlus");
		resultTypes[2] = Class.forName("ij.text.TextPanel");
		resultNames = new String[3];
		resultNames[0] = "Result";
		resultNames[1] = "PathsImage";
		resultNames[2] = "TrackMeasurements";
	}
	
	public void doIt() {
		ImagePlus inputImage = this.getInputImage();
		this.mTrack2Plugin = null;
		result = inputImage;
		MRIMTrack2_ plugin = this.getMTrack2Plugin();
		plugin.run(result.getProcessor());
		this.setResult(plugin.getLablesImage());
		this.setPathsImage(plugin.getPathsImage());
		if (this.getShowPaths()) this.getPathsImage().show();
		this.setTrackMeasurements(plugin.getResultText());
	}
	
	/**
	 * @return
	 */
	private MRIMTrack2_ getMTrack2Plugin() {
		if (mTrack2Plugin==null) {
			mTrack2Plugin = new MRIMTrack2_();
			MRIMTrack2_.setMinSize(this.getMinSize());
			MRIMTrack2_.setMaxSize(this.getMaxSize());
			MRIMTrack2_.setMinTrackLength(this.getMinTrackLength());
			if ( this.getResultFilename()!=null && this.getResultFilename().trim().length()!=0) {
				MRIMTrack2_.setSaveResultsFile(true);
				mTrack2Plugin.setFilename(this.getFilename().substring(
								this.getFilename().lastIndexOf(File.separator), this.getFilename().length()));
				mTrack2Plugin.setDirectory(this.getFilename().substring(
						0, this.getFilename().lastIndexOf(File.separator)));
			} else {
				MRIMTrack2_.setSaveResultsFile(false);
			}
			MRIMTrack2_.setShowLabels(this.getShowLabels());
			MRIMTrack2_.setShowPositions(this.getShowPositions());
			MRIMTrack2_.setShowPaths(this.getShowPaths());
			MRIMTrack2_.setShowPathLengths(this.getShowPathLengths());
			MRIMTrack2_.setMaxVelocity(this.getMaxVelocity());
			MRIMTrack2_.setMaxColumns(this.getMaxColumns());
			mTrack2Plugin.setup("", result);
		}
		return mTrack2Plugin;
	}

	/**
	 * @return Returns the maxColumns.
	 */
	public int getMaxColumns() {
		return maxColumns.getIntegerValue();
	}
	/**
	 * @param maxColumns The maxColumns to set.
	 */
	public void setMaxColumns(int maxColumns) {
		this.maxColumns.setValue(Integer.toString(maxColumns));
	}
	/**
	 * @return Returns the maxSize.
	 */
	public int getMaxSize() {
		return maxSize.getIntegerValue();
	}
	/**
	 * @param maxSize The maxSize to set.
	 */
	public void setMaxSize(int maxSize) {
		this.maxSize.setValue(Integer.toString(maxSize));
	}
	/**
	 * @return Returns the maxVelocity.
	 */
	public int getMaxVelocity() {
		return maxVelocity.getIntegerValue();
	}
	/**
	 * @param maxVelocity The maxVelocity to set.
	 */
	public void setMaxVelocity(int maxVelocity) {
		this.maxVelocity.setValue(Integer.toString(maxVelocity));
	}
	/**
	 * @return Returns the minSize.
	 */
	public int getMinSize() {
		return minSize.getIntegerValue();
	}
	/**
	 * @param minSize The minSize to set.
	 */
	public void setMinSize(int minSize) {
		this.minSize.setValue(Integer.toString(minSize));
	}
	/**
	 * @return Returns the minTrackLength.
	 */
	public int getMinTrackLength() {
		return minTrackLength.getIntegerValue();
	}
	/**
	 * @param minTrackLength The minTrackLength to set.
	 */
	public void setMinTrackLength(int minTrackLength) {
		this.minTrackLength.setValue(Integer.toString(minTrackLength));
	}
	/**
	 * @return Returns the resultFilename.
	 */
	public String getResultFilename() {
		return resultFilename.getValue();
	}
	/**
	 * @param resultFilename The resultFilename to set.
	 */
	public void setResultFilename(String resultFilename) {
		this.resultFilename.setValue(resultFilename);
	}
	/**
	 * @return Returns the showLabels.
	 */
	public boolean getShowLabels() {
		return showLabels.getBooleanValue();
	}
	/**
	 * @param showLabels The showLabels to set.
	 */
	public void setShowLabels(boolean showLabels) {
		this.showLabels.setValue(Boolean.toString(showLabels));
	}
	/**
	 * @return Returns the showPathLengths.
	 */
	public boolean getShowPathLengths() {
		return showPathLengths.getBooleanValue();
	}
	/**
	 * @param showPathLengths The showPathLengths to set.
	 */
	public void setShowPathLengths(boolean showPathLengths) {
		this.showPathLengths.setValue(Boolean.toString(showPathLengths));
	}
	/**
	 * @return Returns the showPaths.
	 */
	public boolean getShowPaths() {
		return showPaths.getBooleanValue();
	}
	/**
	 * @param showPaths The showPaths to set.
	 */
	public void setShowPaths(boolean showPaths) {
		this.showPaths.setValue(Boolean.toString(showPaths));
	}
	/**
	 * @return Returns the showPositions.
	 */
	public boolean getShowPositions() {
		return showPositions.getBooleanValue();
	}
	/**
	 * @param showPositions The showPositions to set.
	 */
	public void setShowPositions(boolean showPositions) {
		this.showPositions.setValue(Boolean.toString(showPositions));
	}
	
	protected void setupOptions() {
		options = new Options(); 
		options.setName(this.name() + " options");
		String[] optionsNames = this.getOptionsNames();
		
		this.minSize = new Option();
		this.setMinSize(1);
		this.minSize.setName(optionsNames[0]);
		options.add(minSize);
		
		this.maxSize = new Option();
		this.setMaxSize(999999);
		this.maxSize.setName(optionsNames[1]);
		options.add(maxSize);
		
		this.minTrackLength = new Option();
		this.setMinTrackLength(2);
		this.minTrackLength.setName(optionsNames[2]);
		options.add(minTrackLength);
		
		this.maxVelocity = new Option();
		this.setMaxVelocity(10);
		this.maxVelocity.setName(optionsNames[3]);
		options.add(maxVelocity);
		
		this.resultFilename = new Option();
		resultFilename.beForFilename();
		this.resultFilename.setName(optionsNames[4]);
		options.add(resultFilename);
		
		this.showLabels = new BooleanOption();
		this.setShowLabels(true);
		this.showLabels.setName(optionsNames[5]);
		options.add(showLabels);
		
		this.showPositions = new BooleanOption();
		this.setShowPositions(false);
		this.showPositions.setName(optionsNames[6]);
		options.add(showPositions);
		
		this.showPaths = new BooleanOption();
		this.setShowPaths(true);
		this.showPaths.setName(optionsNames[7]);
		options.add(showPaths);
		
		this.showPathLengths = new BooleanOption();
		this.setShowPathLengths(true);
		this.showPathLengths.setName(optionsNames[8]);
		options.add(showPathLengths);
		
		this.maxColumns = new Option();
		this.setMaxColumns(75);
		this.maxColumns.setName(optionsNames[9]);
		options.add(maxColumns);
	}
	
	public void connectOptions() {
		minSize  = (Option)options.getOptions().elementAt(0);
		maxSize  = (Option)options.getOptions().elementAt(1);
		minTrackLength  = (Option)options.getOptions().elementAt(2);
		maxVelocity  = (Option)options.getOptions().elementAt(3);
		resultFilename  = (Option)options.getOptions().elementAt(4);
		showLabels  = (BooleanOption)options.getOptions().elementAt(5);
		showPositions  = (BooleanOption)options.getOptions().elementAt(6);
		showPaths  = (BooleanOption)options.getOptions().elementAt(7); 
		showPathLengths = (BooleanOption)options.getOptions().elementAt(8);
		maxColumns  = (Option)options.getOptions().elementAt(9);
	}
	/**
	 * @return Returns the pathsImage.
	 */
	public ImagePlus getPathsImage() {
		return pathsImage;
	}
	/**
	 * @param pathsImage The pathsImage to set.
	 */
	public void setPathsImage(ImagePlus pathsImage) {
		this.pathsImage = pathsImage;
	}
	/**
	 * @return Returns the trackMeasurements.
	 */
	public TextPanel getTrackMeasurements() {
		return trackMeasurements;
	}
	/**
	 * @param trackMeasurements The trackMeasurements to set.
	 */
	public void setTrackMeasurements(TextPanel trackMeasurements) {
		this.trackMeasurements = trackMeasurements;
	}
}
