package controlOperations;

import gui.Option;
import ij.ImagePlus;
import ij.measure.ResultsTable;
import operations.Operation;

public class SkipNoObjectsFoundOperation extends Operation {
	protected ResultsTable objects;
	protected Option numberOfOperations;
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 6753387711732802792L;

	/**
	 * @throws ClassNotFoundException
	 *  
	 */
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		// Set parameterTypes, parameterNames and resultType
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.measure.ResultsTable");
		parameterNames = new String[1];
		parameterNames[0] = "Objects";
		optionsNames = new String[1];
		optionsNames[0] = "number of operations";
		resultTypes = new Class[0];
		resultNames = new String[0];
	}

	public ResultsTable getObjects() {
		return objects;
	}

	public void setObjects(ResultsTable objects) {
		this.objects = objects;
	}
	
	public void doIt() {
		ImagePlus inputImage = this.getInputImage();
		result = inputImage;
		if (this.getObjects().getCounter()<1) {
			application.setProgramCounter(application.getProgramCounter()+this.getNumberOfOperations());
		}
	}

	public int getNumberOfOperations() {
		return numberOfOperations.getIntegerValue();
	}

	public void setNumberOfOperations(int numberOfOperations) {
		this.numberOfOperations.setValue(Integer.toString(numberOfOperations));
	}
	
	protected void setupOptions() {
		super.setupOptions();
		this.setNumberOfOperations(0);
		numberOfOperations.setMin(0);
		numberOfOperations.setShortHelpText("the number of operations to skip");
	}
	
	public void connectOptions() {
		this.numberOfOperations = (Option) this.options.getOptions().elementAt(0);
	}
	
	protected void cleanUpInput() {
		super.cleanUpInput();
		this.setObjects(null);
	}
}
