/*
 * Created on 22.11.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package controlOperations;

import ij.ImagePlus;
import ij.text.TextWindow;
import gui.Option;
import operations.Operation;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SkipSaturatedOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = 6007243096948820332L;
	protected String filename;
	protected TextWindow textWindow;
	
	protected Option maxPercentSaturated;
	protected Option numberOfOperations;
	

	/**
	 * @throws ClassNotFoundException
	 *  
	 */
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		// Set parameterTypes, parameterNames and resultType
		parameterTypes = new Class[2];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterTypes[1] = Class.forName("java.lang.String");
		parameterNames = new String[2];
		parameterNames[0] = "InputImage";
		parameterNames[1] = "Filename";
		optionsNames = new String[2];
		optionsNames[0] = "max. % saturated";
		optionsNames[1] = "number of operations";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultNames = new String[1];
		resultNames[0] = "Result";
	}
	
	/**
	 * @return Returns the maxPercentSaturated.
	 */
	public double getMaxPercentSaturated() {
		return maxPercentSaturated.getDoubleValue();
	}
	
	/**
	 * @param maxPercentSaturated The maxPercentSaturated to set.
	 */
	public void setMaxPercentSaturated(double maxPercentSaturated) {
		this.maxPercentSaturated.setValue(Double.toString(maxPercentSaturated));
	}

	/**
	 * @return Returns the filename.
	 */
	public String getFilename() {
		return filename;
	}
	/**
	 * @param filename The filename to set.
	 */
	public void setFilename(String filename) {
		this.filename = filename;
	}
	
	public void doIt() {
		ImagePlus inputImage = this.getInputImage();
		result = inputImage;
		int maxValue = 255;
		if (result.getType()==ImagePlus.GRAY16) {
			maxValue = 65535;
		}
		int totalNumberOfPixel = result.getWidth() * result.getHeight();
		int numberOfSaturatedPixel = this.getNumberOfSaturatedPixel(maxValue);
		double percent = (numberOfSaturatedPixel * 100) / (totalNumberOfPixel * 1.0);
		if (percent<=this.getMaxPercentSaturated()) {
			return;
		}
		this.getTextWindow().append(this.getFilename() + "\t" + percent + "\n");
		this.getTextWindow().setVisible(true);
		application.setProgramCounter(application.getProgramCounter()+this.getNumberOfOperations());
	}
	
	/**
	 * @return
	 */
	private TextWindow getTextWindow() {
		if (textWindow==null) {
			textWindow = new TextWindow("skipped files", "image\tpercent", "", 300, 200);
		}
		return textWindow;
	}

	/**
	 * @return
	 */
	private int getNumberOfSaturatedPixel(int max) {
		int[] histogram = result.getProcessor().getHistogram();
		int result = histogram[max];
		return result;
	}

	protected void setupOptions() {
		super.setupOptions();
		this.setMaxPercentSaturated(0.5);
		maxPercentSaturated.setMin(0);
		maxPercentSaturated.setMax(100);
		maxPercentSaturated.setShortHelpText("enter the maximal allowed percent of saturated pixel");
		this.setNumberOfOperations(0);
		numberOfOperations.setMin(0);
		numberOfOperations.setShortHelpText("the number of operations to skip");
	}
	
	public void connectOptions() {
		this.maxPercentSaturated = (Option) this.options.getOptions().elementAt(0);
		this.numberOfOperations = (Option) this.options.getOptions().elementAt(1);
	}
	/**
	 * @return Returns the numberOfOperations.
	 */
	public int getNumberOfOperations() {
		return numberOfOperations.getIntegerValue();
	}
	/**
	 * @param numberOfOperations The numberOfOperations to set.
	 */
	public void setNumberOfOperations(int numberOfOperations) {
		this.numberOfOperations.setValue(Integer.toString(numberOfOperations));
	}
	
	/**
	 * 
	 */
	public void resetPathOptions() {
		this.textWindow = null;
		
	}
	
	public void setPathOptionsFromUser() {
		// noop
	}
}
