/*
 * Created on 20.10.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gui;

import ij.ImagePlus;
import ij.WindowManager;
import ij.gui.PolygonRoi;
import ij.gui.Roi;
import ij.io.OpenDialog;
import ij.io.SaveDialog;

import java.awt.Polygon;
import java.awt.geom.Line2D;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.Iterator;
import java.util.Observable;
import java.util.Vector;

import reportingOperations.ReportSegmentsOperation;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class DnaCombingTool extends Observable {
	
	protected DNACombingToolView view;

	protected Vector selections;
	protected Vector imagePaths;
	protected Vector firstSegmentIsGreen;
	protected Vector indexInImage;
	protected Vector selectionStrings;

	private ReportSegmentsOperation reportOperation;

	private String path;
	
	/**
	 * @return Returns the indexInImage.
	 */
	public Vector getIndexInImage() {
		if (indexInImage == null) {
			indexInImage = new Vector();
		}
		return indexInImage;
	}

	/**
	 * @return Returns the firstSegmentIsGreen.
	 */
	public Vector getFirstSegmentIsGreen() {
		if (firstSegmentIsGreen==null) {
			firstSegmentIsGreen = new Vector();
		}
		return firstSegmentIsGreen;
 	}
	/**
	 * @return Returns the selections.
	 */
	public Vector getSelections() {
		if (selections == null) {
			selections = new Vector();
		}
		return selections;
	}
	
	/**
	 * @param string
	 */
	private void changed(String anAspect) {
		this.setChanged();
		this.notifyObservers(anAspect);
	}
	
	public void show() {
		this.view().setVisible(true);
		this.changed("list");
	}

	
	/**
	 * @return Returns the view.
	 */
	public DNACombingToolView view() {
		if (this.view == null) {
			this.view = new DNACombingToolView(this);
		}
		return this.view;
	}
	
	public void addSelection(Boolean firstSegmentIsGreen, String imagePath, Roi selection) {
		if (selection==null) return;
		int pos = this.getSelections().size();
		if (this.getImagePaths().contains(imagePath)) {
			pos = this.getImagePaths().lastIndexOf(imagePath) + 1;
		}
		Integer index = this.getNextIndexFor(imagePath);
		this.getFirstSegmentIsGreen().add(pos, firstSegmentIsGreen);
		this.getImagePaths().add(pos, imagePath);
		this.getSelections().add(pos, selection);
		this.getIndexInImage().add(pos, index);
		this.addSelectionStringFor(firstSegmentIsGreen, imagePath, selection, index, pos);
		this.changed("selections");
	}
	
	/**
	 * @param firstSegmentIsGreen2
	 * @param imagePath
	 * @param selection
	 */
	private void addSelectionStringFor(Boolean firstSegmentIsGreen2, String imagePath, Roi selection, Integer index, int pos) {
		String result = "";
		int startIndex = imagePath.lastIndexOf(File.separator)+1;
		int endIndex = imagePath.lastIndexOf(".");
		String imageName = imagePath.substring(startIndex, endIndex);
		result = result + imageName + " - ";
		result = result + index.toString();
		//result = result + selection.getPolygon().xpoints[0] + ",";
		//result = result + selection.getPolygon().ypoints[0] + "/";
		//result = result + selection.getLength();
		this.getSelectionStrings().add(pos, result);
	}
	
	/**
	 * @param imagePath
	 * @return
	 */
	private Integer getNextIndexFor(String imagePath) {
		int index = 0;
		Iterator it = this.getImagePaths().iterator();
		int counter = 0;
		while(it.hasNext()) {
			String path = (String) it.next();
			if (path.equals(imagePath)) {
				int existingIndex = ((Integer)this.getIndexInImage().elementAt(counter)).intValue();
				index = Math.max(index, existingIndex);
			}
			counter++;
		}
		return new Integer(index+1);
	}

	/**
	 * @return Returns the imagePaths.
	 */
	public Vector getImagePaths() {
		if (imagePaths==null) {
			imagePaths = new Vector();
		}
		return imagePaths;
	}
	/**
	 * @return
	 */
	public Vector getSelectionStrings() {
		if (this.selectionStrings==null) {
			this.selectionStrings = new Vector();
		}
		return selectionStrings;
	}

	/**
	 * @param selectedIndices
	 */
	public void showSelections(int[] selectedIndices) {
		ImagePlus inputImage = WindowManager.getCurrentImage();
		if (inputImage==null) return;
		for (int i=0; i<selectedIndices.length; i++) {
			int index = selectedIndices[i];
			Roi aRoi = (Roi)this.getSelections().elementAt(index);
			inputImage.setRoi(aRoi);
		}
		
	}

	/**
	 * @param selectedIndices
	 */
	public void removeSelections(int[] selectedIndices) {
		for (int i=0; i<selectedIndices.length; i++) {
			int index = selectedIndices[i];
			this.getFirstSegmentIsGreen().remove(index);
			this.getImagePaths().remove(index);
			this.getSelections().remove(index);
			this.getIndexInImage().remove(index);
			this.getSelectionStrings().remove(index);
		}
		this.changed("selections");
	}

	/**
	 * 
	 */
	public void measure() {
		reportOperation = new ReportSegmentsOperation();
		Vector images = new Vector();
		Iterator it = this.getImagePaths().iterator();
		while (it.hasNext()) {
			String pathName = (String) it.next();
			if (!images.contains(pathName)) {
				images.add(pathName);
			}
		}
		it = images.iterator();
		while (it.hasNext()) {
			String path = (String)it.next();
			this.measureImage(path);
		}
	}

	/**
	 * @param path
	 */
	private void measureImage(String path) {
		Vector baseSegments = this.getBaseSegments(path);
		Vector subsegments = this.getSubsegments(path);
		reportOperation.setBaseSegments(baseSegments);
		reportOperation.setSegments(subsegments);
		reportOperation.setImageName(path);
		reportOperation.run();
		reportOperation.setOutputPath(reportOperation.getOutputPath());
	}

	/**
	 * @param path
	 * @return
	 */
	private Vector getSubsegments(String path) {
		Vector result = new Vector();
		Iterator it = this.getImagePaths().iterator();
		int index = 0;
		while (it.hasNext()) {
			String currentPath = (String)it.next();
			if (!currentPath.equals(path)){index++; continue;}
			result.addAll(this.getSubsegmentsForIndex(index));
			index++;
		}
		return result;
	}

	/**
	 * @param index
	 * @return
	 */
	private Vector getSubsegmentsForIndex(int index) {
		Vector result = new Vector();
		Polygon currentPolygon = ((Roi)(this.getSelections().elementAt(index))).getPolygon();
		int pointCounter = 0;
		if (!((Boolean)this.getFirstSegmentIsGreen().elementAt(index)).booleanValue()) {
			pointCounter = 1;
		}
		while(pointCounter<currentPolygon.npoints-1) {
			Line2D line = new Line2D.Float(currentPolygon.xpoints[pointCounter], 
					   currentPolygon.ypoints[pointCounter],								
					   currentPolygon.xpoints[pointCounter+1],
					   currentPolygon.ypoints[pointCounter+1]
					   );
			result.add(line);
			pointCounter = pointCounter + 2;
		}
		return result;
	}

	/**
	 * @param path
	 * @return
	 */
	private Vector getBaseSegments(String path) {
		Vector result = new Vector();
		Iterator it = this.getImagePaths().iterator();
		int index = 0;
		while (it.hasNext()) {
			String currentPath = (String)it.next();
			if (!currentPath.equals(path)){index++; continue;}
			Polygon currentPolygon = ((Roi)(this.getSelections().elementAt(index))).getPolygon();
			Line2D line = new Line2D.Float(currentPolygon.xpoints[0], 
										   currentPolygon.ypoints[0],								
										   currentPolygon.xpoints[currentPolygon.npoints-1],
										   currentPolygon.ypoints[currentPolygon.npoints-1]
										   );
			result.add(line);
			index++;
		}
		return result;
	}

	/**
	 * 
	 */
	public void saveAs() {
		String defaultDir = OpenDialog.getDefaultDirectory();
		SaveDialog saveDialog = new SaveDialog("Save data", "selection", ".sel");
		String filename = saveDialog.getFileName();
		if (filename==null) {
			return;
		}
		String folder = saveDialog.getDirectory();
		path = folder + filename;
		OpenDialog.setDefaultDirectory(defaultDir);
		this.save(path);
	}

	/**
	 * @param path2
	 */
	public void save(String path) {
		   Writer output = null;
		    try {
		    	
		      //use buffering
		      output = new BufferedWriter( new FileWriter(new File(path)) );
		      this.putOn(output);
		    } catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		    finally {
		      //flush and close both "output" and its underlying FileWriter
		      if (output != null)
				try {
					output.close();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
		    }
	}

	/**
	 * @param output
	 */
	private void putOn(Writer output) {
		try {
			output.write(path + "\n");
			output.write(this.getSelections().size()+"\n");
			for (int i=0; i<this.getSelections().size(); i++) {
				String name = (String) this.getSelectionStrings().elementAt(i);
				output.write(name + "\n");
				
				PolygonRoi aRoi = (PolygonRoi)this.getSelections().elementAt(i);
				this.putSelectionOn(aRoi, output);
				
				String imagePath = (String) this.getImagePaths().elementAt(i);
				output.write(imagePath + "\n");
				
				Boolean isGreen = (Boolean) this.getFirstSegmentIsGreen().elementAt(i);
				output.write(isGreen + "\n");
				
				Integer index = (Integer) this.getIndexInImage().elementAt(i);
				output.write(index + "\n");
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * @param roi
	 * @param output
	 */
	private void putSelectionOn(PolygonRoi roi, Writer output) {
		try {
			output.write(roi.getPolygon().npoints + "\n");
			for (int i=0; i<roi.getPolygon().npoints; i++) {
				output.write(roi.getPolygon().xpoints[i] + "," + roi.getPolygon().ypoints[i] + "\n");
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	/**
	 * 
	 */
	public void open() {
		String defaultDir = OpenDialog.getDefaultDirectory();
		OpenDialog openDialog = new OpenDialog("Open data", "selection", ".sel");
		String filename = openDialog.getFileName();
		if (filename==null) {
			return;
		}
		String folder = openDialog.getDirectory();
		path = folder + filename;
		OpenDialog.setDefaultDirectory(defaultDir);
		this.open(path);
		this.changed("selections");
	}

	/**
	 * @param path2
	 */
	private void open(String aPath) {
		BufferedReader input = null;
	    try {
	    	
	      //use buffering
	    	input = new BufferedReader( new FileReader(new File(path)) );
	      this.readFrom(input);
	    } catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	    finally {
	      //flush and close both "output" and its underlying FileWriter
	      if (input != null)
			try {
				input.close();
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
	    }
		
	}

	/**
	 * @param input
	 */
	private void readFrom(BufferedReader input) {
		try {
			input.readLine();
			int numberOfSelections = Integer.parseInt(input.readLine());
			this.reset();
			for (int i=0; i<numberOfSelections; i++) {
				this.getSelectionStrings().add(input.readLine());
				Roi aRoi = this.readSelection(input);
				this.getSelections().add(aRoi);
				this.getImagePaths().add(input.readLine());
				this.getFirstSegmentIsGreen().add(new Boolean(Boolean.parseBoolean(input.readLine())));
				this.getIndexInImage().add(new Integer(Integer.parseInt(input.readLine())));
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	/**
	 * @param input
	 * @return
	 */
	private Roi readSelection(BufferedReader input) {
		int numberOfPoints = 0;
		int[] x = new int[0];
		int[] y = new int[0];
		try {
			numberOfPoints = Integer.parseInt(input.readLine());
			x = new int[numberOfPoints];
			y = new int[numberOfPoints];
			for (int i = 0; i < numberOfPoints; i++) {
				String line;
				line = input.readLine();
				String[] point = line.split(",");
				x[i] = Integer.parseInt(point[0]);
				y[i] = Integer.parseInt(point[1]);
			}
		} catch (NumberFormatException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		PolygonRoi aRoi = new PolygonRoi(x, y, numberOfPoints, Roi.POLYLINE);
		return aRoi;
	}

	/**
	 * 
	 */
	private void reset() {
		selections = null;
		imagePaths = null;
		firstSegmentIsGreen = null;
		indexInImage = null;
		selectionStrings = null;
	}

	/**
	 * 
	 */
	public void measureAll() {
		// TODO Auto-generated method stub
		
	}

	/**
	 * @return
	 */
	public String getPath() {
		return path;
	}
}
