package gui;

import java.awt.BorderLayout;
import javax.swing.JPanel;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;

public class ObjectExtractor3DView extends JFrame implements Observer {

	/**
	 * 
	 */
	private static final long serialVersionUID = 8440334044282913991L;
	private JPanel jContentPane = null;
	private ObjectExtractor3D model;
	private JMenuBar mainMenuBar = null;
	private JMenu fileMenu = null;
	private JMenuItem openMenuItem = null;
	private JMenuItem getActiveStackMenuItem = null;

	public void update(Observable arg0, Object arg1) {
		// TODO Auto-generated method stub

	}

	/**
	 * This is the default constructor
	 */
	public ObjectExtractor3DView() {
		super();
		initialize();
	}

	public ObjectExtractor3DView(ObjectExtractor3D extractor3D) {
		super();
		this.model = extractor3D;
		model.addObserver(this);
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 200);
		this.setJMenuBar(getMainMenuBar());
		this.setContentPane(getJContentPane());
		this.setTitle("MRI 3D object extractor");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
		}
		return jContentPane;
	}

	/**
	 * This method initializes mainMenuBar	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */
	private JMenuBar getMainMenuBar() {
		if (mainMenuBar == null) {
			mainMenuBar = new JMenuBar();
			mainMenuBar.add(getFileMenu());
		}
		return mainMenuBar;
	}

	/**
	 * This method initializes fileMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getFileMenu() {
		if (fileMenu == null) {
			fileMenu = new JMenu();
			fileMenu.setText("File");
			fileMenu.add(getOpenMenuItem());
			fileMenu.add(getGetActiveStackMenuItem());
		}
		return fileMenu;
	}

	/**
	 * This method initializes openMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getOpenMenuItem() {
		if (openMenuItem == null) {
			openMenuItem = new JMenuItem();
			openMenuItem.setText("open stack");
			openMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					model.openStack();
				}
			});
		}
		return openMenuItem;
	}

	/**
	 * This method initializes getActiveStackMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getGetActiveStackMenuItem() {
		if (getActiveStackMenuItem == null) {
			getActiveStackMenuItem = new JMenuItem();
			getActiveStackMenuItem.setText("get active stack");
			getActiveStackMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
				}
			});
		}
		return getActiveStackMenuItem;
	}

}
