/*
 * Created on 09.08.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package help;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JOptionPane;

import config.Configuration;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class HelpSystem {
	static protected HelpSystem current; 

	/**
	 * @return Returns the current.
	 */
	public static HelpSystem getCurrent() {
		if (current == null) {
			current = new HelpSystem(); 
		}
		return current;
	}
	
	/**
	 * @param current The current to set.
	 */
	public static void setCurrent(HelpSystem current) {
		HelpSystem.current = current;
	}

	/**
	 * @param string
	 */
	public void openHelpFor(String operatorName) {
		this.openHelpFor(operatorName, null);
	}
	
	/**
	 * @return
	 */
	private String fileExtension() {
		return ".html";
	}

	/**
	 * @return
	 */
	public static String baseFolder() {
		// return "C:\\Programme\\MRI cell image analyzer\\_help";
		String folder = System.getProperty("user.dir") + "//_help";
		return folder;
	}

	/**
	 * @param operationName
	 * @param name
	 */
	public void openHelpFor(String anOperation, String anOption) {
		String helpFileName = baseFolder() + File.separator + anOperation
				+ fileExtension();
		File helpFile = new File(helpFileName);
		String url = "";
		if (helpFile.exists()) {
			try {
				url = "file://" + helpFile.getCanonicalPath();
				if (anOption != null && !anOption.equals("")) {
					String optionName = anOption.replace(" ", "_");
					url += "#" + optionName;
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
			BrowserControl.displayURL(url);
		} else {
			int answer = JOptionPane.showConfirmDialog(null, "A help for " + anOperation + " doesn't exist. Do you want to create it now?", 
										  "Create help file?", JOptionPane.YES_NO_OPTION);
			if (answer==JOptionPane.NO_OPTION) return;
			this.createNewHelpFile(helpFile, anOperation);
			this.editHelpFile(helpFile);
		}
	}

	/**
	 * @param helpFile
	 */
	private void editHelpFile(File helpFile) {
		String editor = Configuration.current().htmlEditor();
		String[] params = new String[1];
		params[0] = helpFile.getAbsolutePath();
		try {
			String command = editor + " " + "\"" + helpFile.getAbsolutePath() + "\"";
			System.out.println(command);
			Runtime.getRuntime().exec("cmd /C " + command);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	/**
	 * @param helpFile
	 */
	private void createNewHelpFile(File helpFile, String anOperation) {
		File template = new File(baseFolder() + File.separator + helpTemplateFile());
		BufferedReader in = null;
		BufferedWriter out = null;
		try {
			FileReader reader = new FileReader(template);
			FileWriter writer = new FileWriter(helpFile);
			in = new BufferedReader(reader);
			out = new BufferedWriter(writer);
			String line = null;
			while ((line = in.readLine()) != null) {
				if (line.contains("Operation: &lt;name&gt;")) {
					line = line.replace("&lt;name&gt;", anOperation);
				}
				out.write(line);
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			if (in!=null) {
				try {
					in.close();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
			if (out!=null) {
				try {
					out.close();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
		}
	}

	/**
	 * @return
	 */
	static public String helpTemplateFile() {
		return "help template.html";
	}
}
