/*
 * Created on 03.10.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package neuronJNewGUI;
import java.io.File;
import java.io.FileFilter;
import java.util.Arrays;
import java.util.Collections;
import java.util.Observable;
import java.util.Vector;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class LookupTableSelector extends Observable {
	protected LookupTableSelectorView view;
	protected String selectedLUT;
	protected File[] fileLUTS;
	protected Vector lutNames;
	
	public LookupTableSelector() {
		super();
		this.initialize();
	}
	/**
	 * 
	 */
	protected void initialize() {
		selectedLUT = "gray";
		this.readFileLUTS();
	}
	/**
	 * 
	 */
	protected void readFileLUTS() {
		File dir = new File("_lut");
		String[] extensions = {"lut"};
		FileFilter aFilter = new FilesOnlyFileFilter(extensions, "");
		fileLUTS = dir.listFiles(aFilter);
	}
	/**
	 * 
	 */
	public void show() {
		if (view == null) {
			view = new LookupTableSelectorView(this);
		}
		view.setVisible(true);
		this.changed("fileLuts");
		this.changed("selectedLut");
	}
	/**
	 * @return Returns the fileLUTS.
	 */
	public File[] getFileLUTS() {
		return fileLUTS;
	}
	/**
	 * @param fileLUTS The fileLUTS to set.
	 */
	public void setFileLUTS(File[] fileLUTS) {
		this.fileLUTS = fileLUTS;
	}
	/**
	 * @return Returns the selectedLUT.
	 */
	public String getSelectedLUT() {
		return selectedLUT;
	}
	/**
	 * @param selectedLUT The selectedLUT to set.
	 */
	public void setSelectedLUT(String selectedLUT) {
		this.selectedLUT = selectedLUT;
		this.changed("lutDrawing");
	}
	
	public String[] getFileLUTNames() {
		String[] fileLUTNames = new String[fileLUTS.length];
		for (int i=0; i<this.getFileLUTS().length;i++) {
			String filename = this.getFileLUTS()[i].getName();
			int index = filename.indexOf('.');
			String shortName = filename.substring(0,index);
			fileLUTNames[i] = shortName.toLowerCase();
		}
		return fileLUTNames;
	}
	
	public Vector getAllLutNames() {
		Vector allLookupTableNames = new Vector();
		allLookupTableNames.addAll(this.lutNames());
		allLookupTableNames.addAll(Arrays.asList(this.getFileLUTNames()));
		Collections.sort(allLookupTableNames);
		return allLookupTableNames;
	}
	/**
	 * @param string
	 */
	private void changed(String anAspect) {
		this.setChanged();
		this.notifyObservers(anAspect);
	}
	
	public Vector lutNames() {
		if (lutNames == null) {
			lutNames = new Vector();
			lutNames.add("red");
			lutNames.add("green");
			lutNames.add("blue");
			lutNames.add("cyan");
			lutNames.add("magenta");
			lutNames.add("yellow");
			lutNames.add("grays");
			lutNames.add("fire");
			lutNames.add("ice");
			lutNames.add("spectrum");
			lutNames.add("3-3-2 RGB");
			lutNames.add("redgreen");
		}
		return lutNames;
	}
	
	/**
	 * @param lookupTable2
	 * @return
	 */
	public String getFullLutNameFor(String lutName) {
		LookupTableSelector lookupTableSelector = new LookupTableSelector();
		if (lookupTableSelector.lutNames().contains(lutName)) {
			return lutName;
		}
		Vector fileLutNames = new Vector();
		fileLutNames.addAll(Arrays.asList(lookupTableSelector.getFileLUTNames()));
		int index = fileLutNames.indexOf(lutName);
		return lookupTableSelector.getFileLUTS()[index].getAbsolutePath();
	}
}
