package operations;

import ij.IJ;
import ij.ImagePlus;
import ij.WindowManager;

public abstract class FilterOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = -3535262582995593558L;

	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultNames = new String[1];
		resultNames[0] = "Result";
	}
	
	public void doIt() {
		ImagePlus inputImage = this.getInputImage();
		result = this.getCopyOfOrReferenceTo(inputImage, inputImage.getTitle());
		WindowManager.setTempCurrentImage(result);
		this.runFilter();
		result = IJ.getImage();
		WindowManager.setTempCurrentImage(null);
	}

	abstract public void runFilter();
}
