/*
 * Created on 05.01.2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package particleTracking;

import java.awt.Color;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.ListIterator;

import ij.IJ;
import ij.ImagePlus;
import ij.ImageStack;
import ij.io.SaveDialog;
import ij.measure.ResultsTable;
import ij.plugin.filter.ParticleAnalyzer;
import ij.process.ByteProcessor;
import ij.process.ImageProcessor;
import ij.text.TextPanel;
import ij.text.TextWindow;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class MRIMTrack2_ extends MTrack2_ {
	
	private TextPanel resultText;
	private ImagePlus nimp;
	private ImagePlus paths;

	public static void setMinSize(int size) {
		minSize = size;
	}
	
	public static void setMaxSize(int size) {
		maxSize = size;
	}
	
	public static void setMinTrackLength(int length) {
		minTrackLength = length;
	}
	
	public static void setSaveResultsFile(boolean value) {
		bSaveResultsFile = value;
	}
	
	public void setFilename(String aFilename) {
		filename = aFilename;
	}
	
	public void setDirectory(String aFilename) {
		directory = aFilename;
	}
	
	public void run(ImageProcessor ip) {
		/*		GenericDialog gd = new GenericDialog("Object Tracker");
				gd.addNumericField("Minimum Object Size (pixels): ", minSize, 0);
				gd.addNumericField("Maximum Object Size (pixels): ", maxSize, 0);
		                gd.addNumericField("Maximum Velocity:", maxVelocity, 0);
				gd.addNumericField("Minimum track length (frames)", minTrackLength, 0);
				gd.addCheckbox("Save Results File", bSaveResultsFile);
				gd.addCheckbox("Display Path Lengths", bShowPathLengths);
				gd.addCheckbox("Show Labels", bShowLabels);
				gd.addCheckbox("Show Positions", bShowPositions);
				gd.addCheckbox("Show Paths", bShowPaths);
				gd.showDialog();
				if (gd.wasCanceled())
					return; 
				minSize = (int)gd.getNextNumber();
				maxSize = (int)gd.getNextNumber();
				maxVelocity = (float)gd.getNextNumber();
				minTrackLength = (int)gd.getNextNumber();
				bSaveResultsFile = gd.getNextBoolean();
				bShowPathLengths = gd.getNextBoolean();
				bShowLabels = gd.getNextBoolean();
				bShowPositions = gd.getNextBoolean();
				bShowPaths = gd.getNextBoolean();
				*/
				if (bShowPositions)
					bShowLabels =true;
				if (bSaveResultsFile) {
					SaveDialog sd=new  SaveDialog("Save Track Results","trackresults",".txt");
					directory=sd.getDirectory();
					filename=sd.getFileName();
				}
				track(imp, minSize, maxSize, maxVelocity, directory, filename);
			}
			

			public void track(ImagePlus imp, int minSize, int maxSize, float maxVelocity, String directory, String filename) {
				int nFrames = imp.getStackSize();
				if (nFrames<2) {
					IJ.showMessage("Tracker", "Stack required");
					return;
				}

				ImageStack stack = imp.getStack();
				int options = 0; // set all PA options false
				int measurements = CENTROID;

				// Initialize results table
				ResultsTable rt = new ResultsTable();
				rt.reset();

				// create storage for particle positions
				List[] theParticles = new ArrayList[nFrames];
				int trackCount=0;

				// record particle positions for each frame in an ArrayList
				for (int iFrame=1; iFrame<=nFrames; iFrame++) {
					theParticles[iFrame-1]=new ArrayList();
					rt.reset();
					ParticleAnalyzer pa = new ParticleAnalyzer(options, measurements, rt, minSize, maxSize);
					pa.analyze(imp, stack.getProcessor(iFrame));
					float[] sxRes = rt.getColumn(ResultsTable.X_CENTROID);				
					float[] syRes = rt.getColumn(ResultsTable.Y_CENTROID);
					if (sxRes==null)
						return;

					for (int iPart=0; iPart<sxRes.length; iPart++) {
						particle aParticle = new particle();
						aParticle.x=sxRes[iPart];
						aParticle.y=syRes[iPart];
						aParticle.z=iFrame-1;
						theParticles[iFrame-1].add(aParticle);
					}
					IJ.showProgress((double)iFrame/nFrames);
				}

				// now assemble tracks out of the particle lists
				// Also record to which track a particle belongs in ArrayLists
				List theTracks = new ArrayList();
				for (int i=0; i<=(nFrames-1); i++) {
					IJ.showProgress((double)i/nFrames);
					for (ListIterator j=theParticles[i].listIterator();j.hasNext();) {
						particle aParticle=(particle) j.next();
						if (!aParticle.inTrack) {
							// This must be the beginning of a new track
							List aTrack = new ArrayList();
							trackCount++;
							aParticle.inTrack=true;
							aParticle.trackNr=trackCount;
							aTrack.add(aParticle);
							// search in next frames for more particles to be added to track
							boolean searchOn=true;
							particle oldParticle=new particle();
							particle tmpParticle=new particle();
							oldParticle.copy(aParticle);
							for (int iF=i+1; iF<=(nFrames-1);iF++) {
								boolean foundOne=false;
								particle newParticle=new particle();
								for (ListIterator jF=theParticles[iF].listIterator();jF.hasNext() && searchOn;) { 
									particle testParticle =(particle) jF.next();
									float distance = testParticle.distance(oldParticle);
									// record a particle when it is within the search radius, and when it had not yet been claimed by another track
									if ( (distance < maxVelocity) && !testParticle.inTrack) {
										// if we had not found a particle before, it is easy
										if (!foundOne) {
											tmpParticle=testParticle;
											testParticle.inTrack=true;
											testParticle.trackNr=trackCount;
											newParticle.copy(testParticle);
											foundOne=true;
										}
										else {
											// if we had one before, we'll take this one if it is closer.  In any case, flag these particles
											testParticle.flag=true;
											if (distance < newParticle.distance(oldParticle)) {
												testParticle.inTrack=true;
												testParticle.trackNr=trackCount;
												newParticle.copy(testParticle);
												tmpParticle.inTrack=false;
												tmpParticle.trackNr=0;
												tmpParticle=testParticle;
											}
											else {
												newParticle.flag=true;
											}	
										}
									}
									else if (distance < maxVelocity) {
									// this particle is already in another track but could have been part of this one
									// We have a number of choices here:
									// 1. Sort out to which track this particle really belongs (but how?)
									// 2. Stop this track
									// 3. Stop this track, and also delete the remainder of the other one
									// 4. Stop this track and flag this particle:
										testParticle.flag=true;
									}
								}
								if (foundOne)
									aTrack.add(newParticle);
								else
									searchOn=false;
								oldParticle.copy(newParticle);
							}
							theTracks.add(aTrack);
						}
					}
				}

				// Create the column headings based on the number of tracks
				// with length greater than minTrackLength
				// since the number of tracks can be larger than can be accomodated by Excell, we deliver the tracks in chunks of maxColumns
				// As a side-effect, this makes the code quite complicated
				String strHeadings = "Frame";
				int frameCount=1;
				for (ListIterator iT=theTracks.listIterator(); iT.hasNext();) {
					List bTrack=(ArrayList) iT.next();
					if (bTrack.size() >= minTrackLength) {
						if (frameCount <= maxColumns)
							strHeadings += "\tX" + frameCount + "\tY" + frameCount +"\tFlag" + frameCount;
						frameCount++;
					}
				}

				String contents="";
				boolean writefile=false;
				if (filename != null) {
					File outputfile=new File (directory,filename);
					if (!outputfile.canWrite()) {
						try {
							outputfile.createNewFile();
						}
						catch (IOException e) {
							IJ.showMessage ("Error", "Could not create "+directory+filename);
						}
					}
					if (outputfile.canWrite())
						writefile=true;
					else
						IJ.showMessage ("Error", "Could not write to " + directory + filename);
				}

				String flag;
				int repeat=(int) ( (frameCount/maxColumns) );
				float reTest = (float) frameCount/ (float) maxColumns;
				if (reTest > repeat)
					repeat++;
				// display the table with particle positions
				// first when we only write to the screen
				if (!writefile) {
					TextWindow resultsWindow = new TextWindow("Results", "", 300, 200);
					resultText = resultsWindow.getTextPanel();
					resultsWindow.dispose();
					resultText.setColumnHeadings(strHeadings);
					//IJ.setColumnHeadings(strHeadings);

					for (int j=1; j<=repeat;j++) {
						int to=j*maxColumns;
						if (to > frameCount-1)
							to=frameCount-1;
						String stLine="Tracks " + ((j-1)*maxColumns+1) +" to " +to;
						resultText.append(stLine);
						//IJ.write(stLine);
						for(int i=0; i<=(nFrames-1); i++) {
							String strLine = "" + (i+1);
							int trackNr=0;
							int listTrackNr=0;
							for (ListIterator iT=theTracks.listIterator(); iT.hasNext();) {
								trackNr++;
								List bTrack=(ArrayList) iT.next();
								boolean particleFound=false;
								if (bTrack.size() >= minTrackLength) {
									listTrackNr++;
									if ( (listTrackNr>((j-1)*maxColumns)) && (listTrackNr<=(j*maxColumns))) {
										for (ListIterator k=theParticles[i].listIterator();k.hasNext() && !particleFound;) {
											particle aParticle=(particle) k.next();
											if (aParticle.trackNr==trackNr) {
												particleFound=true;
												if (aParticle.flag) 
													flag="*";
												else
													flag=" ";
												strLine+="\t" + aParticle.x + "\t" + aParticle.y + "\t" + flag;
											}
										}
										if (!particleFound)
											strLine+="\t \t \t ";
									}
								}
							}
							resultText.append(strLine);
							//IJ.write(strLine);
						}
					}
				}
				// and now when we write to file
				if (writefile) {
					try {
						File outputfile=new File (directory,filename);
						BufferedWriter dos= new BufferedWriter (new FileWriter (outputfile));
						dos.write(strHeadings+"\n",0,strHeadings.length()+1);
						for (int j=1; j<=repeat;j++) {
							int to=j*maxColumns;
							if (to > frameCount-1)
								to=frameCount-1;
							String stLine="Tracks " + ((j-1)*maxColumns+1) +" to " +to;
							dos.write(stLine + "\n",0,stLine.length()+1);
							for (int i=0; i<=(nFrames-1); i++) {
								String strLine = "" + (i+1);
								int trackNr=0;
								int listTrackNr=0;
								for (ListIterator iT=theTracks.listIterator(); iT.hasNext();) {
									trackNr++;
									List bTrack=(ArrayList) iT.next();
									boolean particleFound=false;
									if (bTrack.size() >= minTrackLength) {
										listTrackNr++;
										if ( (listTrackNr>((j-1)*maxColumns)) && (listTrackNr<=(j*maxColumns))) {
											for (ListIterator k=theParticles[i].listIterator();k.hasNext() && !particleFound;) {
												particle aParticle=(particle) k.next();
												if (aParticle.trackNr==trackNr) {
													particleFound=true;
													if (aParticle.flag) 
														flag="*";
													else
														flag=" ";
													strLine+="\t" + aParticle.x + "\t" + aParticle.y + "\t" + flag;
												}
											}
											if (!particleFound)
												strLine+="\t \t \t ";
										}
									}
								}
								dos.write(strLine + "\n",0,strLine.length()+1);
							}
						}
						if (bShowPathLengths) {
							double[] lengths = new double[trackCount];
							double[] distances = new double[trackCount];
							int[] frames = new int[trackCount];
							double x1, y1, x2, y2;
							int trackNr=0;
							int displayTrackNr=0;
							for (ListIterator iT=theTracks.listIterator(); iT.hasNext();) {
								trackNr++;
								List bTrack=(ArrayList) iT.next();
								if (bTrack.size() >= minTrackLength) {
									displayTrackNr++;
									ListIterator jT=bTrack.listIterator();
									particle oldParticle=(particle) jT.next();
									particle firstParticle=new particle();
									firstParticle.copy(oldParticle);
									frames[displayTrackNr-1]=bTrack.size();
									for (;jT.hasNext();) {
										particle newParticle=(particle) jT.next();
										lengths[displayTrackNr-1]+=Math.sqrt(sqr(oldParticle.x-newParticle.x)+sqr(oldParticle.y-newParticle.y));
										oldParticle=newParticle;
									}
									distances[displayTrackNr-1]=Math.sqrt(sqr(oldParticle.x-firstParticle.x)+sqr(oldParticle.y-firstParticle.y));
								}
							}
							dos.write("\n");
							dos.write("Track \tLength\tDistance traveled\tNr of Frames\n",0,45);
							for (int i=0; i<displayTrackNr; i++) {
								String str = "" + (i+1) + "\t" + (float)lengths[i] + "\t" + (float)distances[i] + "\t" + (int)frames[i];
								dos.write(str+"\n",0,str.length()+1);
							}
						}
						dos.close();
					}
					catch (IOException e) {
						if (filename != null)
							IJ.error ("An error occurred writing the file. \n \n " + e);
					}
				}

				// Now do the fancy stuff when requested:

				// makes a new stack with objects labeled with track nr
				// optionally also displays centroid position
				if (bShowLabels) {
					String strPart;
					ImageStack newstack = imp.createEmptyStack();
					int xHeight=newstack.getHeight();
					int yWidth=newstack.getWidth();
					for (int i=0; i<=(nFrames-1); i++) {
						int iFrame=i+1;
						String strLine = "" + i;
						ImageProcessor ip = stack.getProcessor(iFrame);
						newstack.addSlice(stack.getSliceLabel(iFrame),ip.crop());
						ImageProcessor nip = newstack.getProcessor(iFrame);
						nip.setColor(Color.black);
						// hack to only show tracks longerthan minTrackLength
						int trackNr=0;
						int displayTrackNr=0;
						for (ListIterator iT=theTracks.listIterator(); iT.hasNext();) {
							trackNr++;
							List bTrack=(ArrayList) iT.next();
							if (bTrack.size() >= minTrackLength) {
								displayTrackNr++;
								for (ListIterator k=theParticles[i].listIterator();k.hasNext();) {
									particle aParticle=(particle) k.next();
									if (aParticle.trackNr==trackNr) {
										strPart=""+displayTrackNr;
										if (bShowPositions) {
											strPart+="="+(int)aParticle.x+","+(int)aParticle.y;
										}
										// we could do someboundary testing here to place the labels better when we are close to the edge
										nip.moveTo((int)aParticle.x+5,doOffset((int)aParticle.y,yWidth,5) );
										//nip.moveTo(doOffset((int)aParticle.x,xHeight,5),doOffset((int)aParticle.y,yWidth,5) );
										nip.drawString(strPart);
									}
								}
							}
						}
						IJ.showProgress((double)iFrame/nFrames);
					}
					nimp = new ImagePlus(imp.getTitle() + " labels",newstack);
				//	nimp.show();
				//	imp.show();
				//	nimp.updateAndDraw();
				}


				// total length traversed
				if (bShowPathLengths && !writefile) {
					double[] lengths = new double[trackCount];
					double[] distances = new double[trackCount];
					int[] frames = new int[trackCount];
					double x1, y1, x2, y2;
					int trackNr=0;
					int displayTrackNr=0;
					for (ListIterator iT=theTracks.listIterator(); iT.hasNext();) {
						trackNr++;
						List bTrack=(ArrayList) iT.next();
						if (bTrack.size() >= minTrackLength) {
							displayTrackNr++;
							ListIterator jT=bTrack.listIterator();
							particle oldParticle=(particle) jT.next();
							particle firstParticle=new particle();
							firstParticle.copy(oldParticle);
							frames[displayTrackNr-1]=bTrack.size();
							for (;jT.hasNext();) {
								particle newParticle=(particle) jT.next();
								lengths[displayTrackNr-1]+=Math.sqrt(sqr(oldParticle.x-newParticle.x)+sqr(oldParticle.y-newParticle.y));
								oldParticle=newParticle;
							}
							distances[displayTrackNr-1]=Math.sqrt(sqr(oldParticle.x-firstParticle.x)+sqr(oldParticle.y-firstParticle.y));
						}
					}
					resultText.append("");
					resultText.append("Track \tLength\tDistance traveled\tNr of Frames");
					//IJ.write("");
					//IJ.write("Track \tLength\tDistance traveled\tNr of Frames");
					for (int i=0; i<displayTrackNr; i++) {
						String str = "" + (i+1) + ":\t" + (float)lengths[i] + "\t" + (float)distances[i] + "\t" + (int)frames[i];
						resultText.append(str);
						//IJ.write(str);
					}
				}


				// 'map' of tracks
				if (bShowPaths) {
					if (imp.getCalibration().scaled()) {
						IJ.showMessage("MultiTracker", "Cannot display paths if image is spatially calibrated");
						return;
					}
					ImageProcessor ip = new ByteProcessor(imp.getWidth(), imp.getHeight());
					ip.setColor(Color.white);
					ip.fill();
					trackCount=0;
					int color;
					for (ListIterator iT=theTracks.listIterator();iT.hasNext();) {
						trackCount++;
						List bTrack=(ArrayList) iT.next();
						if (bTrack.size() >= minTrackLength) {
							ListIterator jT=bTrack.listIterator();
							particle oldParticle=(particle) jT.next();
							for (;jT.hasNext();) {
								particle newParticle=(particle) jT.next();
								color =Math.min(trackCount+1,254);
								ip.setValue(color);
								ip.moveTo((int)oldParticle.x, (int)oldParticle.y);
								ip.lineTo((int)newParticle.x, (int)newParticle.y);
								oldParticle=newParticle;
							}
						}
					}
					paths = new ImagePlus("Paths", ip);
				}
			}
	public TextPanel getResultText() {
		return resultText;
	}

	public ImagePlus getLablesImage() {
		return nimp;
	}
	
	public ImagePlus getPathsImage() {
		return paths;
	}

	/**
	 * @param showLabels
	 */
	public static void setShowLabels(boolean value) {
		bShowLabels = value;
	}

	/**
	 * @param showPositions
	 */
	public static void setShowPositions(boolean value) {
		bShowPositions = value;
	}

	/**
	 * @param showPaths
	 */
	public static void setShowPaths(boolean value) {
		bShowPaths = value;
	}

	/**
	 * @param showPathLengths
	 */
	public static void setShowPathLengths(boolean value) {
		bShowPathLengths = value;
	}

	/**
	 * @param maxVelocity
	 */
	public static void setMaxVelocity(float velocity) {
		maxVelocity = velocity;
		
	}

	/**
	 * @param maxColumns
	 */
	public static void setMaxColumns(int columns) {
		maxColumns = columns;
	}
}
