/*
 * Created on 24.01.2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package processingOperations;

import analysisOperations.FindObjectsOperation;
import ij.ImagePlus;
import ij.ImageStack;
import ij.measure.ResultsTable;
import ij.process.ImageProcessor;
import operations.Operation;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class AdaptiveErodeOperation extends Operation {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -6603131749230528452L;
	
	ImagePlus tmpImage = null;
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultNames = new String[1];
		resultNames[0] = "Result";
	}
	
	public void doIt() {
		ImagePlus inputImage = this.getInputImage();
		result = this.getCopyOfOrReferenceTo(inputImage, inputImage.getTitle());
		this.processSlices();
	}
	
	protected void doItForSlice(int sliceNumber, ImageStack stack) {
		ImageProcessor ip = stack.getProcessor(sliceNumber);
		int lastCount=0;
		int currentCount=0;
		int iterations = 0;
		 while (lastCount<=currentCount) {
		 	tmpImage = this.copyImage(inputImage, inputImage.getTitle());
			lastCount = this.countObjects();
			ip.erode();
			currentCount = this.countObjects();
			iterations++;
		}
		result = tmpImage;
	}


	/**
	 * 
	 */
	protected int countObjects() {
		FindObjectsOperation findObjectsOperation = new FindObjectsOperation();
		findObjectsOperation.setInputImage(result);
		findObjectsOperation.setMinSize(1);
		findObjectsOperation.setShowResult(false);
		findObjectsOperation.setExcludeEdgeObjects(false);
		findObjectsOperation.run();
		ResultsTable measurements = findObjectsOperation.getMeasurements();
		return measurements.getCounter();
	}
}
