/*
 * Created on 25.01.2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package processingOperations;

import java.util.Vector;

import ij.ImagePlus;
import ij.ImageStack;
import ij.process.ImageProcessor;
import gui.Option;
import operations.Operation;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class GridMaximaOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = 5490831546934375930L;
	
	Option gridWidth;
	Option gridHeight;
	
	Vector xMaxima;
	Vector yMaxima;
	Vector iMaxima;
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		optionsNames = new String[2];
		optionsNames[0] = "grid width";
		optionsNames[1] = "grid height";
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultNames = new String[1];
		resultNames[0] = "Result";
	}
	
	public void connectOptions() {
		this.gridWidth = (Option) this.options.getOptions().elementAt(0);
		this.gridHeight = (Option) this.options.getOptions().elementAt(1);
	}
	
	protected void setupOptions() {
		super.setupOptions();
		this.setGridWidth(100);
		this.setGridHeight(130);
	}
	/**
	 * @return Returns the gridHeight.
	 */
	public int getGridHeight() {
		return gridHeight.getIntegerValue();
	}
	/**
	 * @param gridHeight The gridHeight to set.
	 */
	public void setGridHeight(int gridHeight) {
		this.gridHeight.setValue(Integer.toString(gridHeight));
	}
	/**
	 * @return Returns the gridWidth.
	 */
	public int getGridWidth() {
		return gridWidth.getIntegerValue();
	}
	/**
	 * @param gridWidth The gridWidth to set.
	 */
	public void setGridWidth(int gridWidth) {
		this.gridWidth.setValue(Integer.toString(gridWidth));
	}
	
	public void doIt() {
		ImagePlus inputImage = this.getInputImage();
		result = this.getCopyOfOrReferenceTo(inputImage, inputImage.getTitle());
		this.processSlices();
	}
	
	protected void doItForSlice(int sliceNumber, ImageStack stack) {
		ImageProcessor ip = stack.getProcessor(sliceNumber);
		int gridWidth = this.getGridWidth();
		int gridHeight = this.getGridHeight();
		int xSteps = (ip.getWidth() / gridWidth) + 1;
		int ySteps = (ip.getHeight() / gridHeight) + 1;
		for (int x=0; x<xSteps; x++) {
			for (int y=0; y<ySteps; y++) {
				 this.findMaxima(x*gridWidth, y*gridHeight, sliceNumber, gridWidth, gridHeight, stack);
				 this.zeroNoneMaximaInRegion(x*gridWidth,y*gridHeight, sliceNumber, gridWidth, gridHeight, stack);
			}
		}
	}

	/**
	 * @param x
	 * @param y
	 */
	protected void zeroNoneMaximaInRegion(int startX, int startY, int z, int width, int height, ImageStack stack) {
		ImageProcessor ip = stack.getProcessor(z);
		for (int x=startX; x<startX+width; x++) {
			for (int y=startY; y<startY+height; y++) {
				ip.putPixel(x,y, 0);
			}
		}
		for (int i=0; i<xMaxima.size(); i++) {
				int x = ((Integer)xMaxima.elementAt(i)).intValue();
				int y = ((Integer)yMaxima.elementAt(i)).intValue();
				int intensity = ((Integer)iMaxima.elementAt(i)).intValue();
				ip.putPixel(x,y, intensity);
		}
	}

	/**
	 * 
	 */
	protected void findMaxima(int startX, int startY, int z, int width, int height, ImageStack stack) {
		ImageProcessor ip = stack.getProcessor(z);
		xMaxima = new Vector();
		yMaxima = new Vector();
		iMaxima = new Vector();
		int maximumIntensity = this.getLocalMaximumIntensity(startX, startY, width, height, ip);
		for (int x=startX; x<startX+width; x++) {
			for (int y=startY; y<startY+height; y++) {
				int intensity = ip.getPixel(x,y);
				if (intensity != maximumIntensity) continue;
				xMaxima.add(new Integer(x));
				yMaxima.add(new Integer(y));
				iMaxima.add(new Integer(intensity));
			}	
		}
	}

	/**
	 * @param startX
	 * @param startY
	 * @param width
	 * @param height
	 * @param ip
	 */
	private int getLocalMaximumIntensity(int startX, int startY, int width, int height, ImageProcessor ip) {
		double mean = result.getStatistics().mean;
		double threshold = mean / 4.0;
		int maximum = 0;
		for (int x=startX; x<startX+width; x++) {
			for (int y=startY; y<startY+height; y++) {
				int intensity = ip.getPixel(x,y);
				if (intensity<=threshold) continue;
				if (intensity>maximum) maximum = intensity;
			}	
		}
		return maximum;
	}
}
