/*
 * Created on 13.10.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package reportingOperations;

import reporting.ExcelIO;
import reporting.ExcelWriter;
import ij.measure.ResultsTable;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ReportMeasurementsOperation extends ReportingOperation {
	/**
	 * 
	 */
	private static final long serialVersionUID = -118837904231449374L;
	
	protected ResultsTable measurements;
	
	/**
	 * @return Returns the measurements.
	 */
	public ResultsTable getMeasurements() {
		return measurements;
	}
	/**
	 * @param measurements The measurements to set.
	 */
	public void setMeasurements(ResultsTable measurements) {
		this.measurements = measurements;
	}
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		// Set parameterTypes, parameterNames and resultType
		parameterTypes = new Class[2];
		parameterTypes[0] = Class.forName("ij.measure.ResultsTable");
		parameterTypes[1] = Class.forName("java.lang.String");
		parameterNames = new String[2];
		parameterNames[0] = "Measurements";
		parameterNames[1] = "ImageName";
	}
	
	public void doIt() {
	    setupOutputPath();
		ExcelIO excelIO = this.loadOrCreateWorkbook(3);
		ExcelWriter excelProxy = new ExcelWriter();
		excelProxy.setWb(excelIO.wb);
		excelProxy.setSheet(excelIO.s);
		excelProxy.setSheet(excelIO.wb.getSheetAt(0));
		this.createHeadingsFirstSheet(excelProxy, excelIO);
		this.createHeadingsSecondSheet(excelProxy, excelIO);
		this.reportAverage(excelIO, excelProxy);
		for (int i=0; i<this.getMeasurements().getCounter(); i++) {
			this.reportMeasurement(excelIO, excelProxy, i);
		}
		this.saveWorkbook(excelIO.wb);
	}

	/**
	 * 
	 */
	private void reportMeasurement(ExcelIO excelIO, ExcelWriter excelProxy, int i) {
		excelProxy.setSheet(excelIO.wb.getSheetAt(1));
		String row = this.getImageName() + "\t";
		row = row + this.getMeasurements().getRowAsString(i) + "\t";
		row = row + this.getImageFolder();
		excelProxy.writeTabSeparatedDataAsRow(row);
		excelProxy.setSheet(excelIO.wb.getSheetAt(1));
	}
	/**
	 * 
	 */
	private void reportAverage(ExcelIO excelIO, ExcelWriter excelProxy) {
		excelProxy.setSheet(excelIO.wb.getSheetAt(0));
		String row = this.getImageName() + "\t";
		row = row + this.getMeasurements().getCounter() + "\t";
		this.getMeasurements();
		for (int i=0; i<ResultsTable.MAX_COLUMNS; i++) {
			String data = this.getAverageForColumn(i);
			if (data!=null) {
				row = row + this.getAverageForColumn(i) + "\t";
			}
		}
		row = row + this.getImageFolder();
		excelProxy.writeTabSeparatedDataAsRow(row);
		excelProxy.setSheet(excelIO.wb.getSheetAt(1));
	}
	/**
	 * @param i
	 * @return
	 */
	private String getAverageForColumn(int i) {
		float[] column = this.getMeasurements().getColumn(i);
		if (column==null) return null;
		double average = 0.0;
		for (int row=0; row<column.length; row++) {
			average = average + column[row];
		}
		average = average / ((column.length)*1.0);
		String result = Double.toString(average);
		return result;
	}
	/* (non-Javadoc)
	 * @see reportingOperations.ReportingOperation#headingsFirstSheet()
	 */
	protected String headingsFirstSheet() {
		String headings = "image\tnumber of objects";
		headings = headings + this.getMeasurements().getColumnHeadings() + "\tfolder";
		return headings;
	}

	/* (non-Javadoc)
	 * @see reportingOperations.ReportingOperation#getSheetName(int)
	 */
	protected String getSheetName(int i) {
		String[] names = {"objects averages", "objects"};
		return names[i];
	}
	
	protected String headingsSecondSheet() {
		String headings = "image";
		headings = headings + "\t" + this.getMeasurements().getColumnHeadings();
		headings = headings + "\tfolder";
		return headings;
	}
	
	protected void cleanUpInput() {
		super.cleanUpInput();
		this.setMeasurements(null);
	}
}
