package stack;
import ij.ImagePlus;
import ij.gui.ImageWindow;
import ij.gui.StackWindow;

public class MeasureStackReviewer implements Runnable {
	protected ImagePlus imp;
	protected Thread thread;
	protected int reviewTime = 50;
	public MeasureStackReviewer(ImagePlus imp){
		this.imp = imp;
		thread = new Thread(this, "Reviewer");
		thread.start();
	}
	public void run(){
		ImageWindow win = imp.getWindow();
		int numSlices = imp.getStackSize();
		if (!(win instanceof StackWindow))
			return;
		StackWindow swin = (StackWindow)win;
			Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
			int oldSlice = imp.getCurrentSlice();
			for (int slice = 1; slice <= numSlices; slice++){
				imp.setSlice(slice);
				try {Thread.sleep(reviewTime);}
				catch(InterruptedException e) {}
			}
			imp.setSlice(oldSlice);
		}
}
